<!DOCTYPE html>
<?php
  setlocale(LC_ALL, 'en_US.UTF8');
  header('Content-Type:text/html; charset=UTF-8');

$rtndir = "index.php";
if (isset($_GET["id"])) {
  $p_id = $_GET["id"];
} else {
  header("Location: $rtndir");
  exit;
}

$rtndir = "viewWork.php?id=$p_id";
if (isset($_GET["sfcid"])) {
  $sfcid = $_GET["sfcid"];
} else {
  header("Location: $rtndir");
  exit;
}
if (isset($_GET["line"])) {
  $line = $_GET["line"];
} elseif (isset($_GET["p_line"])) {
  $line = $_GET["p_line"];
} else {
  $line = "0";
}
$p_line = $line;

$hideDifferences = 0;
if (isset($_GET["hideDifferences"]) && $_GET["hideDifferences"] == 1) { $hideDifferences = 1; }

$hideNames = 0;
if (isset($_GET["hideNames"]) && $_GET["hideNames"] == 1) { $hideNames = 1; }

$autoCollate = 0;
if (isset($_GET["auto_collate"]) && $_GET["auto_collate"] == 1) { $autoCollate = 1; }

$diffChecked = "";
if ($hideDifferences == 0) { $diffChecked = "checked=\"checked\""; }
$nameChecked = "";
if ($hideNames == 0) { $nameChecked = "checked=\"checked\""; }
$autoChecked = "";
if ($autoCollate == 1) { $autoChecked = "checked=\"checked\""; }


$hideAry = array();
if (isset($_GET["hideTabs"])) {
  $hideAry = explode(';',$_GET["hideTabs"]);
  $hideAry = array_flip($hideAry);
}

  include "dromio_config.php";
  include 'DromioCollation.php';

  $witAry = array();
  $x = new DromioDocument($p_id);
  $pageAry = $x->getValue("//TEI:surface[@xml:id='$sfcid']/TEI:media/@url");
  if (count($pageAry)) { $p_img = $pageAry[0]; }
  
  $respAry = $x->getSurfaceTranscribers($sfcid);
  $witCount = count($respAry);
  if (count($respAry)) {
    foreach ($respAry as $resp) {
      $p_text = $x->getDromioTranscription($sfcid,$resp);
      $p_text = preg_replace('/&amp;/','&',$p_text);
      $p_text = preg_replace('/&lt;/','<',$p_text);
      $p_text = preg_replace('/&gt;/','>',$p_text);
      $p_text = preg_replace('/<lb\/?>/',' \\n ',$p_text);
      $p_text = preg_replace('/<br\/?>/',' \\n ',$p_text);
      $p_text = preg_replace('/<.*?>/','',$p_text);
      $p_text = preg_replace('/\s+/',' ',$p_text);
      $p_text = preg_replace('/(\\\\n )+$/','',$p_text);
      $p_text = preg_replace('/( )+$/','',$p_text);
      if ($p_text) { 
        $witAry[] = new DromioWitness($resp,$p_text);
      }
    }
  }
  
  $collation = new DromioCollation($witAry);
  $witAry = $collation->getTexts();
  $xml = $collation->showXML();
  preg_match_all('/<line n="(.*?)">/',$xml,$lines);
  $lineAry = $lines[1];
?>
<html>
<head>
<title>Collate</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style type="text/css" media="screen,print">@import "dromio.css";</style>
<script  type="text/javascript">
  var box;
  var transcriptionCounts = new Array();
  var maxCounts = new Array();
  var maxLines = <?php echo count($lineAry); ?>;

  var dragObj;
  var dragX = 0;
  var dragY = 0;
  function dragMarker(event,tableId) {
    dragObj = document.getElementById(tableId);
    event.dataTransfer.setData('text/html',dragObj);
    dragX = event.clientX;
    dragY = event.clientY;
    dragObj.style.color = "red";
    document.ondragover = dragOverMarker;
    document.ondrop = dropMarker;
  }
  function dropMarker(event) {
    snapToGrid(dragObj);
    dragObj.style.color = "black";
    dragObj = null;
    dragX = 0;
    dragY = 0;
    collateTexts();
    event.preventDefault();
    return false;
  }
  function dragOverMarker(event) {
    var left = parseInt(dragObj.style.left); if (isNaN(left)) { left = 0; }
    left += event.clientX - dragX;
    var top = parseInt(dragObj.style.top); if (isNaN(top)) { top = 0; }
    top += event.clientY - dragY;
    dragObj.style.left = left + "px";
    dragObj.style.top  = top  + "px";
    dragX = event.clientX;
    dragY = event.clientY;
    event.preventDefault();
    return false;
  }
  function snapToGrid(obj) {
    var gridX = 50;
    var gridY = 22;
    var rect = obj.getBoundingClientRect();
    var left = parseInt(obj.style.left); if (isNaN(left)) { left = 0; }
    var top  = parseInt(obj.style.top);  if (isNaN(top)) { top = 0; }
    var dX = rect.left % gridX;
    var dY = rect.top % gridY;
    if (dX > gridX/2) { dX = dX - gridX; }
    if (dY > gridY/2) { dY = dY - gridY; }
    obj.style.left = left - dX + "px"; 
    obj.style.top = top - dY + "px"; 
  }

  function addImageBox(img) {
    document.getElementById("menuFrame").style.height = document.getElementById('CollateNow').offsetHeight+"px"; 

    if (img) {
      box = new FloatingImage(img);
      box.position = {left:.02*document.body.clientWidth,top:50};
      box.size = {width:.96*document.body.clientWidth,height:250};
    } else {
      document.getElementById('textholder').style.top = "70px";
    }
    showTabs();
    if (document.getElementById('autoCollate').value=='Y') { collate(); }
  }

  function selectPreviousLine() {
    var lineNo = parseInt(document.getElementById('p_line').value);
    if (lineNo > 0) {
      document.getElementById('p_line').value = lineNo - 1;
    }
    selectLine();
  }
  function selectNextLine() {
    var lineNo = parseInt(document.getElementById('p_line').value);
    var count = document.getElementById('p_line').length - 1;
    if (lineNo < count) {
      document.getElementById('p_line').value = lineNo + 1;
    }
    selectLine();
  }
  function selectLine() {
    var lineNo = document.getElementById('p_line').value;
    var lines = document.getElementsByClassName("collateLine");
    for (var i=0; i<lines.length; i++) {
      var line = lines[i];
      if (lineNo == 0) { line.style.display = "block"; }
      else {
        var id = line.id;
        var lineLine = id.substr(id.indexOf('-')+1);
        if (lineNo == lineLine) {
          var witnessNbr = id.substr(0,id.indexOf('-'));
          witnessNbr = witnessNbr.substr(4);
          var spanId = id.replace("text","hidden");
          var textSpan = document.getElementById(spanId);
          var table = document.getElementById("table"+witnessNbr);
          if (textSpan && textSpan.innerHTML == "") {
            table.style.display = "none";
          } else {
            table.style.display = "block";
            var nameElement = document.getElementById("marker"+witnessNbr).title;
            nameElement = nameElement.replace(' ','');
            nameElement = nameElement.replace('&amp;','&');
            hideElement = document.getElementById("show_"+nameElement);
            if (!hideElement.checked) { table.style.display = "none"; }
          }
          line.style.display = "block";
        } else {
          line.style.display = "none";
        }
      }
    }
    collateTexts();
  }

  function autoZoomImage() {
    var objElement = document.getElementById("imgContent");
    var imgElement = document.getElementById("image1");
    var origW = parseInt(imgElement.offsetWidth);
    if (zoomFactor == 1) {
      zoomFactor= (.98*imgW) / origW;
      document.getElementById("magnifyPct").innerHTML = parseInt(zoomFactor * 100) + "%";
      imgElement.width= (.98*imgW);
    }
    document.getElementById("magnifyPct").innerHTML = parseInt(zoomFactor * 100) + "%";
    return true;
  }
  function toggleCollate() {
    if (document.getElementById("autoCollate").checked==1) {
      document.getElementById("auto_collate").value='Y';
    } else {
      document.getElementById("auto_collate").value='';
      unCollate();
    }
  }

  function showOptions() {
    optionsBox = document.getElementById("options");
    if (document.getElementById("options").style.display == "none" || document.getElementById("options").style.display == "") {
      document.getElementById("options").style.display = "block";
      document.getElementById("options").style.left = document.getElementById('CollateNow').offsetLeft - parseInt(document.getElementById('options').offsetWidth) + "px"; 
      document.getElementById("options").style.top = document.getElementById('CollateNow').offsetTop + 30 +  "px"; 
    } else {
      document.getElementById("options").style.display = "none";
    }
  }
  function showDiff() {
    if (document.getElementById('showDiffs').checked == true) {
      document.getElementById('hideDifferences').value = "0";
    } else {
      document.getElementById('hideDifferences').value = "1";
    }
    collateTexts();
  }
  function showName() {
    if (document.getElementById('showNames').checked == true) {
      document.getElementById('hideNames').value = "0";
    } else {
      document.getElementById('hideNames').value = "1";
    }
    var markers = document.getElementsByClassName("marker");
    var cnt = markers.length;
    for (var i = 0; i < cnt; i++) {
      var marker = markers[i];
      var name = marker.title;
      tabElement = document.getElementById("tab_"+name);
      if (document.getElementById('showNames').checked == true) { } else { name = i+1; }
      if (tabElement) { tabElement.innerHTML = name; }
      marker.innerHTML = name;
    }
  }
  function showTabs() {
    var markers = document.getElementsByClassName("marker");
    var cnt = markers.length;
    for (var i = 0; i < cnt; i++) {
      tableElement = document.getElementById("table"+i);
      if (tableElement) {
        var name = document.getElementById("marker"+i).title;
        name = name.replace(' ','');
        name = name.replace('&amp;','&');
        hideElement = document.getElementById("show_"+name);
        if (hideElement.checked) {
          tableElement.style.display = "block";
          document.getElementById('hideTabs').value = document.getElementById('hideTabs').value.replace(";"+name,'');
        } else {
          tableElement.style.display = "none";
          if (document.getElementById('hideTabs').value.indexOf(name) == -1) { document.getElementById('hideTabs').value += ";"+name; }
        }
        snapToGrid(tableElement);
      }
    }
    collateTexts();
  }
  function getTranscriptionPcts(inArray,markerArray) {
    transcriptionCounts = new Array();
    maxCounts = new Array();
    //maxLines defined elsewhere

    var divs = document.getElementsByClassName("transcription");
    for (var i = 0; i < divs.length; i++) {
      var table = divs[i];
      var cnt = table.id.substr(5);
      var transcriptionLineCnt = 0;
      transcriptionCounts[i] = new Array();
      for (var j = 1; j <= maxLines; j++) {
        var span = document.getElementById("hidden"+cnt+"-"+j);
        var words = 0;
        if (span.innerHTML) {
          transcriptionLineCnt++;
          testStr = span.innerHTML.replace(/\u200B/ig,""); 
          testStr = testStr.replace(/^\s*/g,"");
          testStr = testStr.replace(/\s*$/g,"");
          if (testStr.match(/\s/)) {
            words = testStr.match(/\s/g).length + 1;
          } else if (testStr.length) {
            words = 1;
          }
        }
        transcriptionCounts[i][j] = words;
      }
      transcriptionCounts[i][0] = transcriptionLineCnt;
    }
    for (var i = 0; i <= maxLines; i++) {
      maxCounts[i] = new Array();
      for (var j = 0; j < divs.length; j++) {
        if (j == 0) { maxCounts[i] = 0; }
        if (transcriptionCounts[j][i] > maxCounts[i]) { maxCounts[i] = transcriptionCounts[j][i]; }
      }
    }
  }
  function setMarkerBackgrounds(lineNo) {
    var markers = document.getElementsByClassName("marker");
    for (var i = 0; i < markers.length; i++) {
      var marker = markers[i];
      var markerId = marker.id.substr(6);
      var pct = Math.round(100*transcriptionCounts[markerId][lineNo]/maxCounts[lineNo]);
      marker.style.backgroundImage = "linear-gradient(to right, var(--dark-color), var(--dark-color) "+parseInt(pct)+"%, var(--missing-color) "+pct+"%, var(--missing-color)";
    }
  }

  function compareLines(inArray,markerArray) {
    var outArray = [];
    var outString = [];
    var cnt = markerArray.length;
    if (cnt == 0) { return false; }
    var margin = 10;
    var width = (.9*window.innerWidth/cnt) - margin;

    var maxWords = 0;
    for (x in inArray) {
      outArray[x] = inArray[x].split(/ /);
      if (outArray[x].length > maxWords) { maxWords = outArray[x].length; }
    }
    
    //pad each word to max word length, so words line up
    for (n = 0; n < maxWords; n++) {
      maxLength = 0;
      for (x in inArray) {
        if (!outArray[x][n]) { outArray[x][n] = ""; }
        if (outArray[x][n].length > maxLength) { maxLength = outArray[x][n].length; }
      }
      //zero-width spaces (\u2000) shouldn't count as characters
      for (x in inArray) {
        var zwLength = 0;
        var zwsp = String(outArray[x][n]).match(/\u200B/);
        if (zwsp) { zwLength += zwsp.length; }
        while (outArray[x][n].length < (maxLength+zwLength)) {
          outArray[x][n] += " ";
        }
      }
    }

    /*
    For each x, for each n, compare outArray[x][n] to outArray[y][n]
    save changes in a new array, so <font>s won't get in the way of comparison
    use font flags to reduce number of opening and closings?
    if outArray[y][n] is all spaces, don't check
    */

    for (x in outArray) { //for each line...
      testStr = inArray[x].replace(/ /g,"");
      var outStr = "";
      for (n in outArray[x]) { //for each word...
        for (m in outArray[x][n]) { //for each character...
          isMatch = true;
          for (y in outArray) { //for each other line...
            testY = inArray[y].replace(/ /g,"");
            if (x == y) {
            } else if (testY == "") {
            } else if (outArray[y][n][m]) {
              if (outArray[x][n][m] != outArray[y][n][m]) {
                isMatch = false;
              }
            } else {
              isMatch = false;
            }
          }
          var outChar = outArray[x][n][m];
          if (isMatch) {
            outStr += outArray[x][n][m];
          } else {
            outStr += '<font color="red">' + outArray[x][n][m] + '</font>';
          }
        }
        outStr += " ";
      }
      outStr = outStr.replace(/ /g,"&nbsp;");
      outStr = outStr.replace(/font&nbsp;color/g,"font color");
      outStr = outStr.replace(/<\/font><font color="red">/g,"");
      outStr = outStr.replace(/&#160;/g," ");
      outStr = outStr.replace(/&#8203;/g,"&nbsp;");
      outString[x] = outStr;
    }
    return outString;
  }

  function collateTexts() {
    var lineNo = document.getElementById('p_line').value;
    getTranscriptionPcts();
    setMarkerBackgrounds(lineNo);

    var divs = document.getElementsByClassName("transcription");
    //maxLines defined elsewhere

    // Reset the text and get the number of tables
    for (var i = 0; i < divs.length; i++) {
      var table = divs[i];
      var cnt = table.id.substr(5);
      for (var j = 1; j <= maxLines; j++) {
        var span = document.getElementById("span"+cnt+"-"+j);
        if (span) { span.innerHTML = document.getElementById("hidden"+cnt+"-"+j).innerHTML; }
      }
    }

    if (document.getElementById('showDiffs').checked != true) { return; }

    // Detect which tables overlap
    var overlap = new Array();
    var overlapX = 0;
    overlapTest: for (var i = 0; i < divs.length; i++) {
      var div1 = divs[i];
      for (x in overlap) {
        for (y in overlap[x]) {
          if (overlap[x][y] == i) { continue overlapTest; } 
        } 
      } 
      if (div1.style.display == "none") { continue overlapTest; }
      var tx = div1.offsetLeft;
      var ty = div1.offsetTop;
      var tb = ty + div1.clientHeight;
      var tr = tx + div1.clientWidth;

      var overlapY = 0;
      for (var j = i+1; j < divs.length; j++) {
        var div2 = divs[j];
        if (div2.style.display != "none") { 
          var x1 = div2.offsetLeft;
          var y1 = div2.offsetTop;
          var y2 = y1 + div2.clientHeight;
          var x2 = x1 + div2.clientWidth;

          if ((tx >= x1 & tx <= x2 & ty >= y1 & ty <= y2) || (x1 >= tx & x1 <= tr & y1 >= ty & y1 <= tb)) {
            if (overlapY == 0) { 
              overlap[overlapX] = new Array(2); 
              overlap[overlapX][overlapY] = i; 
              overlapY++; 
            }
            overlap[overlapX][overlapY] = j; 
            overlapY++; 
          }
        }
      }
      if (overlapY > 0) { overlapX++; }
    }

    //Detect differences in text among overlapping tables
    var lineCnt = lineNo;
    if (lineNo == 0) { lineNo = 1; lineCnt = maxLines; }
    for (var line = lineNo; line <= lineCnt; line++) {
      for (x in overlap) {
        var spanElement = new Array();
        var markerElement = new Array();
        var inString = new Array();
        var outStr = new Array();
        for (y in overlap[x]) {
          spanElement[y] = document.getElementById("span"+overlap[x][y]+"-"+line);
          markerElement[y] = document.getElementById("marker"+overlap[x][y]);
          if (spanElement[y]) {
            inString[y] = document.getElementById("span"+overlap[x][y]+"-"+line).innerHTML;
            inString[y] = inString[y].replace(/&nbsp;/ig," ");
            inString[y] = inString[y].replace(/(\s+), /ig,", ");
            inString[y] = inString[y].replace(/,(?=\w)/ig,", ");
            inString[y] = inString[y].replace(/<\/ /ig,"</");
            inString[y] = inString[y].replace(/ +/ig," ");
            inString[y] = inString[y].replace(/^\s+/,"");
            inString[y] = inString[y].replace(/<font color="red">/ig,"\x88");
            inString[y] = inString[y].replace(/<\/font>/ig,"\x89");
            inString[y] = inString[y].replace(/<(.*?)>/ig,"");  //remove any unhandled tags
            inString[y] = inString[y].replace(/&lt;/ig,"<");
            inString[y] = inString[y].replace(/&gt;/ig,">");
            inString[y] = inString[y].replace(/&amp;/ig,"&");
          } else {
            inString[y] = "";
          }
          outStr[y] = "";
        }

        outStr = compareLines(inString,markerElement);

        for (y in outStr) {
          outStr[y] = outStr[y].replace(/\x88/ig,"<font color=\"red\">");
          outStr[y] = outStr[y].replace(/\x89/ig,"</font>");
          if (spanElement[y]) {
            spanElement[y].innerHTML = outStr[y];
            markerElement[y].innerHTML = markerElement[y].innerHTML; 
          }
        }

      }
    }
  }

  function collate() {
    var divs = document.getElementsByClassName("transcription");
    for (var i = 0; i < divs.length; i++) {
      var div = divs[i];
      var top = div.offsetTop;
      div.style.position = "absolute";
      div.style.top = "0px";
      div.style.left = "0px";
      snapToGrid(div);
    }
    collateTexts();
  }

  function unCollate() {
    var divs = document.getElementsByClassName("transcription");
    var top = 0;
    for (var i = 0; i < divs.length; i++) {
      var div = divs[i];
      div.style.position = "absolute";
      div.style.top = top+"px";
      div.style.left = "0px";
      top += div.offsetHeight;
      top += parseInt(getComputedStyle(document.body).getPropertyValue('--collation-line-height'));
      snapToGrid(div);
    }
    collateTexts();
  }

</script>
<script  type="text/javascript" src="FloatingBoxClass.js"></script>
<script  type="text/javascript" src="FloatingImageClass.js"></script>
</head>

<body onload="addImageBox('<?php echo "$p_img"; ?>');" >
<div id="menuFrame">
  <div id="lists">
    <form id="form1" name="form1" method="get" style="display:inline; margin:0px" action="collationTest.php"> 
    <div style="float:left;">
    <div style="float:left; width:075px;">
    <a id="back" href="<?php echo $rtndir; ?>" style="color:#305030;">Back</a>
    </div>
    Line: 
    <input type="button" name="prevLine" value="<" onclick="selectPreviousLine();"/>
    <select name="p_line" id="p_line" autocomplete="off" onchange="selectLine();">
      <option value="0" selected>All</option>
<?php
  foreach ($lineAry as $line) {
    $selected = "";
    if ($line == $p_line) { $selected = "selected='selected'"; }
    echo "<option value=\"$line\" $selected>$line</option>\n";
  }
  if ($p_line == 0) { $maxLines = $line; } else { $maxLines = 1; }
?>
    </select>
    <input type="button" id="nextLine" name="nextLine" value=">" onclick="selectNextLine();"/>
    <input type="hidden" id="maxLines" name="maxLines" value="<?php echo "$maxLines"; ?>"/>
    <input type="hidden" id="hideTabs" name="hideTabs" id="hideTabs" value=""/>
    <input type="hidden" id="hideDifferences" name="hideDifferences" value="<?php echo "$hideDifferences"; ?>"/>
    <input type="hidden" id="hideNames" name="hideNames" value="<?php echo "$hideNames"; ?>"/>
    <input type="hidden" id="auto_collate" name="auto_collate" value="<?php echo "$autoCollate"; ?>"/>
    </div>
    </form>
  </div>

  <div style="float:right; width:200px;" id="optionsButton">
    <a href="javascript:showOptions();">Options:</a>
    <input type="button" id="unCollateNow" value="un-" onclick="unCollate();"/>
   	<input type="button" id="CollateNow" value="Collate" onclick="collate();"/>
  </div>
  <div id="options">
    <div id="tabOptions">Show tabs:<br/>   
<?php
    foreach ($witAry as $wit) {
      $witName = $wit->getId();
      $checked = "checked";
      if (isset($hideAry[$witName])) { $checked = ""; }
      echo "      &nbsp;&nbsp;<input type=\"checkbox\" id=\"show_$witName\" $checked onclick=\"showTabs();\"/><span id=\"tab_$witName\">$witName</span><br/>\n";

    }
?>
    </div>
    <div id="collateOptions">Collation:<br/>
    &nbsp;&nbsp;<input type="checkbox" name="showDiffs" id="showDiffs" <?php echo $diffChecked; ?> onclick="showDiff();"/>Show Differences<br/>
    &nbsp;&nbsp;<input type="checkbox" name="showNames" id="showNames" <?php echo $nameChecked; ?> onclick="showName();"/>Show Names<br/>
    &nbsp;&nbsp;<input type="checkbox" name="autoCollate" id="autoCollate" <?php echo $autoChecked; ?> onclick="toggleCollate();collate();"/>Auto Collate<br/>
    </div>
  </div>
</div>

<div id="textholder">
<?php
  $textAry = array();
  if ($p_line != 0) { $lineAry = array($p_line); }
foreach ($lineAry as $line) {
$app = preg_replace("/^.*?<line n=\"$line\">/",'',$xml);
$app = preg_replace('/<\/line>.*$/','',$app);
preg_match_all('/<app>.*?<\/app>/',$app,$words);
foreach ($words[0] as $word) {
  preg_match_all('/<rdg.*?>.*?<\/rdg>/',$word,$rdgs);
  foreach ($rdgs[0] as $rdg) {
    preg_match('/resp="(.*?)"/',$rdg,$respsAry);
    preg_match('/">(.*?)<\/rdg>/',$rdg,$textsAry);
    $resps = $respsAry[1];
    $text = $textsAry[1];
    if (strlen($text)==0) { $text = "&#8203;"; } //add zero-width space to maintain matches from DromioCollation
    $resps = str_replace('#','',$resps);
    $respAry = split(' ',$resps);
    foreach ($respAry as $resp) {
      if (isset($textAry[$resp][$line])) {
        $textAry[$resp][$line] .= " $text";
      } else {
        $textAry[$resp][$line] = $text;
      }
    }
  }
}
}
$tableAry = array();
foreach ($witAry as $wit) {
  $witName = $wit->getId();
  if (!isset($tableAry[$witName])) {
    $tableAry[$witName] = count($tableAry);
    $j = $tableAry[$witName];
    echo "<div id=\"table$j\" class=\"transcription\">\n";
    echo "<div id=\"marker$j\" draggable=\"true\" ondragstart=\"dragMarker(event,'table$j')\" class=\"marker\" style=\"width: calc((95vw / $witCount) - 10px); left: calc(10px + $j * (-00px + 95vw / $witCount));\" title=\"$witName\">$witName</div>\n";
    echo "<span class=\"hidden\" id=\"hidden$j\">$witName</span>\n";
    $l=0;
    foreach ($lineAry as $line) {
      $l++;
      $text = "";
      if (array_key_exists($witName,$textAry) && isset($textAry[$witName][$line])) { 
        $text = $textAry[$witName][$line];
      }
      echo "<span class=\"hidden\" id=\"hidden$j-$l\">$text</span>\n";
      echo "<div id=\"text$j-$l\" class=\"collateLine\"><div class=\"lineNumber\">$line</div><div id=\"span$j-$l\" class=\"collateText\">$text</div></div>\n";
    }
    echo "</div><br/>\n";
  }
}

?>
</div>
</body>
</html>
