<?php
  setlocale(LC_ALL, 'en_US.UTF8');
  header('Content-Type:text/html; charset=UTF-8');
  $hideTags = true;

$rtndir = "index.php";
if (isset($_GET["id"])) {
  $p_id = $_GET["id"];
} elseif (isset($_GET["p_page"])) {
  $p_id = $_GET["p_page"];
} else {
  header("Location: $rtndir");
  exit;
}

$rtndir = "viewWork.php?id=$p_id";
if (isset($_GET["sfcid"])) {
  $sfcid = $_GET["sfcid"];
} else {
  header("Location: $rtndir");
  exit;
}

if (isset($_GET["output"])) {
  $output = $_GET["output"];
} else {
  $output= "table";
}
if (strpos($output,"tagged") !== false) { $hideTags = false; }
  
  include "dromio_config.php";
  include 'DromioCollation.php';

  $witAry = array();
  $x = new DromioDocument($p_id);
  $respAry = $x->getSurfaceTranscribers($sfcid);
  if (count($respAry)) {
    foreach ($respAry as $resp) {
      $p_text = $x->getDromioTranscription($sfcid,$resp);
      $p_text = preg_replace('/&amp;/','&',$p_text);
      $p_text = preg_replace('/&lt;/','<',$p_text);
      $p_text = preg_replace('/&gt;/','>',$p_text);
      $p_text = preg_replace('/<lb\/?>/',' \\n ',$p_text);
      $p_text = preg_replace('/<br\/?>/',' \\n ',$p_text);
      $p_text = preg_replace('/\s+/',' ',$p_text);
      $p_text = preg_replace('/(\\\\n )+$/','',$p_text);
      $p_text = preg_replace('/( )+$/','',$p_text);
      if ($hideTags) {
        $p_text = preg_replace('/\<.*?\>/','',$p_text);
      }
      if ($p_text) { 
        $witAry[] = new DromioWitness($resp,$p_text);
      }
      $p_text = preg_replace('/\<.*?\>/','',$p_text);
      echo "<p><b>$resp:</b> $p_text</p>\n";
    }
  }
  
$collation = new DromioCollation($witAry);
print "<b>Collation</b><br/>\n";
if ($output == "table") {
  $table = $collation->showTable();
  echo $table;
} elseif ($output == "taggedTable") {
  $table = $collation->showTable(true);
  echo $table;
} else {
  if ($output == "taggedXML") {
    $app = $collation->showXML(true);
  } else {
    $app = $collation->showXML();
  }
  $app = preg_replace('/</','&lt;',$app);
  $app = preg_replace('/>/','&gt;',$app);
  $app = preg_replace('/(app&gt;)/','$1<br/>',$app);
  $app = preg_replace('/(\/rdg&gt;)/','$1<br/>',$app);
  $app = preg_replace('/(&lt;.?line.*?&gt;)/','$1<br/>',$app);
  $app = preg_replace('/<br\/>/',"<br/>\n",$app);
  //$app = preg_replace('/(\/line&gt;)/','$1<br/>',$app);
  echo $app;
}
?>
