<?php
include "dromio_config.php";
?>
<!DOCTYPE html>
<html xml:lang="en">
<head>
  <title>Dromio - Folger Shakespeare Library</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <style type="text/css" media="screen,print">@import "dromio.css";</style>
</head>
<body>
  <a id="logo" href="<?php echo $base_url; ?>"></a>
  <div id="contentsDiv">
    <div class="contentsHeader">
      <div class="contentsText">
      <?php if ($dir) { echo "<a class=\"inherit\" href=\"moveWork.php?id=$dir\">$dir</a>"; } ?>&nbsp;
      </div>
      <div class="commandOption"><a class="inherit" href="editWork.php?level=work&dir=<?php echo $dir; ?>">| Add Work</a></div>
    </div>

<?php
if ($dir) {
  echo "<div class=\"contentsRow row0\">\n";
  if (strrpos($dir,'/') > 0) {
    $dir = substr($dir,0,strrpos($dir,'/'));
    echo "<a class=\"inherit\" href=\"".$_SERVER['PHP_SELF']."?dir=$dir\"><b>..</b></a><br/>\n";
  } else {
    echo "<a class=\"inherit\" href=\"".$_SERVER['PHP_SELF']."\"><b>..</b></a><br/>\n";
  }
  echo "</div>\n";
}

$dirAry = array_filter(glob("$base_dir/*"),'is_dir');
foreach ($dirAry as $subdir) {
  $dir = preg_replace("/^$transcription_dir\//",'',$subdir);
  $subdir = str_replace("$base_dir/","",$subdir);
  echo "<div class=\"contentsRow row0\">\n";
  echo "<a class=\"inherit\" href=\"".$_SERVER['PHP_SELF']."?dir=$dir\"><b>$subdir</b></a><br/>\n";
  echo "</div>\n";
}

$i = 0;
$fileAry = glob("$base_dir/*.xml");
foreach ($fileAry as $id) {
  $linkid = preg_replace("/^$transcription_dir\//",'',$id);
  $work = new DromioDocument($linkid);
  $title = $work->getTitle();
  $callNbr = $work->getValue("TEI:teiHeader/TEI:fileDesc/TEI:publicationStmt/TEI:idno");
  if ($callNbr && $callNbr[0]) { $title = $callNbr[0].": $title"; }

  $i++;

  echo "      <div class=\"contentsRow row".($i % 2)."\">\n";
  echo "        <div class=\"contentsText\"><a class=\"inherit\" href=\"viewWork.php?id=$linkid\">$title</a></div>\n";
  echo "        <div class=\"commandOption\"><a class=\"inherit\" href=\"$id\">| View XML</a></div>\n";
  echo "        <div class=\"clear\"></div>\n";
  echo "      </div>\n";

}
?>
  </div>
</body>
</html>

