<?php
include "dromio_config.php";
$rtndir = "index.php";

if (isset($_POST["id"])) {
  $p_id = $_POST["id"];
} elseif (isset($_GET["id"])) {
  $p_id = $_GET["id"];
} else {
  header("Location: $rtndir");
  exit;
}

$rtndir = "viewWork.php?id=$p_id";
if (isset($_POST["sfcid"])) {
  $sfcid = $_POST["sfcid"];
} elseif (isset($_GET["sfcid"])) {
  $sfcid = $_GET["sfcid"];
} else {
  header("Location: $rtndir");
  exit;
}

if (isset($_POST["wid"])) {
  $p_witness = $_POST["wid"];
} elseif (isset($_GET["wid"])) {
  $p_witness = $_GET["wid"];
} else {
  header("Location: $rtndir");
  exit;
}

$x = new DromioDocument($p_id);

?>
<!DOCTYPE html>
<html xml:lang="en">
<head>
<title>Dromio - Folger Shakespeare Library</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style type="text/css" media="screen,print">@import "dromio.css";</style>
</head>
<body>
  <a id="logo" href="<?php echo $base_url; ?>"></a>

<?php

$old_id = "";
$new_id = "";

if (array_key_exists('old_id',$_POST)) { $old_id = $_POST['old_id']; }
if (array_key_exists('new_id',$_POST)) { $new_id = $_POST['new_id']; }
if (array_key_exists('move',$_POST) || array_key_exists('copy',$_POST)) {
  if ($old_id == "") {
    echo "<p class='message'>Old Name cannot be blank.</p>\n";
  } elseif ($new_id == "") {
    echo "<p class='message'>New Name cannot be blank.</p>\n";
  } elseif ($old_id == $new_id) {
    echo "<p class='message'>Nothing to move. New Name matches existing name.</p>\n";
  } elseif (preg_match('/[^a-zA-Z0-9\-\_\.\/]/',$new_id)) {
    echo "<p class='message'>Invalid character in $new_id.</p>\n";
  } else {
    $test = $x->getDromioTranscription($sfcid,$new_id);
    if ($test) {
      echo "<p class='message'>Transcription already exists. Rename or delete $new_id first.</p>\n";
    } else {
      $test = $x->getDromioTranscription($sfcid,$old_id);
      if (!$test) {
        echo "<p class='message'>Transcription $old_id not found.</p>\n";
      } if (array_key_exists('move',$_POST)) {
        $x->setAttributeValue("//TEI:surface[@xml:id='$sfcid']/TEI:zone[@resp='#$old_id']","resp","#".$new_id);
        $x->addDromioWitness($new_id);
        $x->setDromioStatus("moved",$new_id,$sfcid,$old_id);
        $x->writeDoc();
        echo "<p class='message'>Transcription ($old_id) renamed to $new_id.</p>\n";
        $p_witness = $new_id;
        $old_id = $new_id;
        $new_id = "";
      } if (array_key_exists('copy',$_POST)) {
        $nodeList = $x->getElementsByNodePathNS($x->teiNS,"//TEI:surface[@xml:id='$sfcid']/TEI:zone[@resp='#$old_id']");
        foreach ($nodeList as $node) { 
          $newNode = $node->cloneNode(true);
          $newNode->setAttribute("resp","#$new_id");
          $node->parentNode->appendChild($newNode); 
          echo "<p class='message'>Transcription ($old_id) copied to $new_id.</p>\n";
        }
        $x->addDromioWitness($new_id);
        $x->setDromioStatus("copied",$new_id,$sfcid,$old_id);
        $x->writeDoc();
      } else {
      }
    }
  }
} elseif (array_key_exists('delete',$_POST)) {
  if ($old_id == "") {
    echo "<p class='message'>Old Name cannot be blank.</p>\n";
  } else {
    $nodeList = $x->getElementsByNodePathNS($x->teiNS,"//TEI:surface[@xml:id='$sfcid']/TEI:zone[@resp='#$old_id']");
    if ($nodeList->length > 0) {
      foreach ($nodeList as $node) { $x->removeDromioNode($node); }
      $x->setDromioStatus("deleted",$new_id,$sfcid);
      $x->writeDoc();
      echo "<p class='message'>Transcription ($old_id) deleted. <a href=\"viewWork.php?id=$p_id\">Return to Work</a>.</p>\n";
      $p_witness = "";
      $old_id = "";
      $new_id = "";
    } else {
      echo "<p class='message'>Transcription $old_id not found.</p>\n";
    }
  }
} else {
}

if (!isset($id)) { $id = $old_id; }
if (!isset($new_id)) { $new_id = $id; }
if ($x->getMsg('error')) {
  echo "<p class='message'>".$x->getMsg('error')."</p>\n";
}
if ($x->getMsg('warning')) {
  echo "<p class='color:black;'>".$x->getMsg('warning')."</p>\n";
}
$action = "moveTranscription.php?".$_SERVER['QUERY_STRING'];

$delBtn = "<input type=\"submit\" class=\"button\" name=\"delete\" value=\"Delete\" onclick=\"if (!confirm('Are you sure you want to delete this transcription?')) { return false; }\"/>";
$rtnBtn = "        <a class=\"blue\" href=\"viewWork.php?id=$p_id\">Return to Work</a>";

?>
  <div id="contentsDiv">
  <form id="newform" method="post"  action="<?php echo "$action"; ?>">
    <input type="hidden" name="old_id" value="<?php echo "$p_id"; ?>"/>
    <input type="hidden" name="old_id" value="<?php echo "$sfcid"; ?>"/>
    <input type="hidden" name="wid" value="<?php echo "$p_witness"; ?>"/>
    <input type="hidden" name="old_id" value="<?php echo "$p_witness"; ?>"/>
     <div class="contentsHeader">
      <div class="contentsText">
      <?php echo "<a class=\"inherit\" href=\"viewWork.php?id=$p_id\" title=\"Return to Work\">&#9668;</a> $p_id"; ?>&nbsp;
      </div>
      </div>
      <div class="contentsRow">
        <div class="contentsLabel">Surface:</div>
        <div class="contentsText"><?php echo "$sfcid"; ?></div>
        <div class="clear"></div>
      </div>
      <br>
      <div class="contentsRow">
        <div class="contentsLabel">Old name:</div>
        <div class="contentsText"><?php echo "$p_witness"; ?></div>
        <div class="commandOption"><?php echo $delBtn; ?></div>
        <div class="clear"></div>
      </div>
      <br>
      <div class="contentsRow">
        <div class="contentsLabel">New name:</div>
        <div class="contentsInput"><input style="width:280px;" name="new_id" value="<?php echo "$new_id"; ?>" pattern="[a-zA-Z][\w\.-]*"/></div>
        <div class="inputHint">(Valid XML Name)</div>
        <div class="commandOption">
          <input class="button" type="submit" name="copy" value="Copy"/>
          <input class="button" type="submit" name="move" value="Move"/>
        </div>
        <div class="clear"></div>
      </div>

      <div class="resultsRow row1" id="return"><br/><?php echo $rtnBtn; ?></div>

    </div>
  </form>
  </div>

</body>
</html>

