<?php
setlocale(LC_ALL, 'en_US.UTF8');

include "dromio_config.php";
if ($_POST["document"]) {
  $document = $_POST["document"];
} else {
  returnError("Document does not exist");
}
if ($_POST["surface"]) {
  $surface = $_POST["surface"];
} else {
  returnError("Surface does not exist");
}
if ($_POST["witness"]) {
  $witness = $_POST["witness"];
} else {
  returnError("Witness does not exist");
}
$text = "";
if ($_POST["transcription"]) { $text = $_POST["transcription"]; }
$status = "";
if ($_POST["status"]) { $status = $_POST["status"]; }

$x = new DromioDocument($document);
$x->setDromioTranscription($surface,$witness,$text);
if ($status) {
  $x->setDromioStatus($status,$witness,$surface);
}
$x->writeDoc();
if (true) {
} else {
  returnError("Cannot write to file. Invalid XML?");
}
returnSuccess("Success");

function returnError($msg) {
  header('HTTP/1.1 400 Bad Request');
  die($msg);
}
function returnSuccess($msg) {
  header('Content-Type:text/html; charset=UTF-8');
  echo $msg;
}

?>
