﻿<?php
setlocale(LC_ALL, 'en_US.UTF8');
header('Content-Type:text/html; charset=UTF-8');
header('X-XSS-Protection:0');

include "dromio_config.php";
include "DromioCollation.php";
$rtndir = "index.php";
  
if (isset($_GET["id"])) {
  $p_id = $_GET["id"];
} else {
  header("Location: $rtndir");
  exit;
}

$rtndir = "viewWork.php?id=$p_id";
if (isset($_GET["sfcid"])) {
  $sfcid = $_GET["sfcid"];
} else {
  header("Location: $rtndir");
  exit;
}

if (isset($_GET["wid"])) {
  $p_witness = $_GET["wid"];
} else if (isset($_COOKIE['folger_cookie'])) {
   $disp_name = $_COOKIE['folger_cookie'];
   $p_name = str_replace("'","''",$_COOKIE['folger_cookie']);
   $p_name = str_replace("\"","",$p_name);
   $p_name = str_replace(" ","",$p_name);
   $p_witness = $p_name;
} else {
  header("Location: $rtndir");
  exit;
}
$vetWitness = $p_witness;
if (substr($vetWitness,0,4) != "Vet-") { $vetWitness = "Vet-$vetWitness"; }

setcookie ("folger_cookie",$p_witness, time()+60*60*24*7);
$p_witness = preg_replace('/[^a-zA-Z0-9\:\-\_\.]/','',$p_witness);


$x = new DromioDocument($p_id);
$p_page = "";
$pageAry = $x->getValue("//TEI:surface[@xml:id='$sfcid']/TEI:media/@url");
if (count($pageAry)) { $p_page = $pageAry[0]; }

$work_title = $x->getTitle();
$surfaceAry = $x->getSurfaces();
foreach ($surfaceAry as $surface => $n) {
 if ($n && $surface == $sfcid) { $work_title .=": $n"; }
}
$title = "";

if (isset($_GET["exclude"])) {
  $excludeAry = explode(';',$_GET["exclude"]);
} else if (isset($_POST["page_id"])) {
  $excludeAry = explode(';',$_POST["exclude"]);
} else {
  $excludeAry = array();
}
$respAry = $x->getSurfaceTranscribers($sfcid);
if (count($respAry)) {
  foreach ($respAry as $resp) {
    if (in_array($resp,$excludeAry) == false) {
    $p_text = $x->getDromioTranscription($sfcid,$resp);
    $p_text = preg_replace('/&nbsp;/',' ',$p_text);

    $p_text = preg_replace('/&amp;/','&',$p_text);
    $p_text = preg_replace('/&lt;/','<',$p_text);
    $p_text = preg_replace('/&gt;/','>',$p_text);
    $p_text = preg_replace('/<lb\/?>/',' \\n ',$p_text);

    $p_text = preg_replace('/\s+/',' ',$p_text);
    $p_text = preg_replace('/(\\\\n )+$/','',$p_text);
    $p_text = preg_replace('/( )+$/','',$p_text);

    $witAry[] = new DromioWitness($resp,$p_text);
    }
  }
}
$collation = new DromioCollation($witAry);
$witAry = $collation->getTexts();
$xml = $collation->showXML(true);
preg_match_all("/<line n=\"\d*\">(.*?)<\/line>/",$xml,$lines);
$lineAry = $lines[1];

$p_text = "";
$wIdx = 0;
$tagAry = array();
foreach ($lineAry as $line) {
  $needSpace = 0;
  preg_match_all('/<app>.*?<\/app>/',$line,$words);
  foreach ($words[0] as $word) {
    $wIdx++;
    preg_match_all('/<rdg.*?>.*?<\/rdg>/',$word,$rdgs);
    $wordText = "";
    $wordOptions = array();
    $displayOptions = "";
    $wordResps = 0;
    $tags = "";
    $tagColor = "";
    $tagClick = "";

    foreach ($rdgs[0] as $rdg) {
      if ($needSpace) { $p_text .= "&nbsp;"; $needSpace = 0; }
      if (strpos($rdg,'type="word"') !== false) {
        preg_match('/resp="(.*?)"/',$rdg,$respsAry);
        $respCnt = count(split(' ',$respsAry[1]));
        preg_match('/">(.*?)<\/rdg>/',$rdg,$textsAry);
        $text = $textsAry[1];
        if (strlen($text)==0) { $text = " "; }
        if (preg_match('/n="(.*?)"/',$rdg,$nAry)) { $n = $nAry[1]; } else { $n = 0; }

        if ($respCnt > $wordResps || ($respCnt == $wordResps && $wordText == " ")) {
          $wordResps = $respCnt;
          $wordText = $text;
        }
        if (strlen($displayOptions) > 0) { $displayOptions .= " "; }
        if (!in_array($text,$wordOptions)) { $wordOptions[] = $text; }
        $displayText = preg_replace('/<\/.*?>/','~/span~',$wordText);
        $displayText = preg_replace('/<([a-z\-]*).*?>/','<span class=\"$1\">',$displayText);
        $displayText = str_replace('~/span~','</span>',$displayText);
        $displayOptions .= $displayText;
      } elseif (preg_match('/type="tag"/',$rdg,$tagsAry)) {
        if ($wordText) {
          if (count($wordOptions) == 1) { $class = "wordAgreement"; } else { $class = "wordDisagreement"; }
          $title = join(" | ",$wordOptions);
          $title = str_replace('"','&quot;',$title);
          $p_text .= "<span id=\"word_$wIdx\" class=\"$class\" title=\"$title\" onclick=\"vetMenu(this,event);\">$displayText</span>";
          $wordText = "";
          $wordOptions = array();
          $displayOptions = "";
          $wordResps = 0;
        }

        preg_match('/resp="(.*?)"/',$rdg,$respsAry);
        $respCnt = count(split(' ',$respsAry[1]));
        preg_match('/">(.*?)<\/rdg>/',$rdg,$textsAry);
        $text = $textsAry[1];
        if (strpos('n="i"/',$rdg) !== false) {
          $wordText = "&#171;";
        } elseif (strpos('n="f"/',$rdg) !== false) {
          $wordText = "&#172;";
        }

        if (strpos($rdg,'type="tag" n="i"') !== false) {
          preg_match('/resp="(.*?)"/',$rdg,$respsAry);
          $respCnt = count(split(' ',$respsAry[1]));
          preg_match('/">(.*?)<\/rdg>/',$rdg,$textsAry);
          $text = $textsAry[1];
          preg_match('/xml:id="(.*?)"/',$rdg,$idAry);
          $id = $idAry[1];
          $txt = "&#171;";
          $txt = "&lsaquo;";
          $title = $text;
          $title = str_replace('_',' ',$title);
          $title = str_replace('::',"=''",$title);
          $title = str_replace(':',"''",$title);
          $class = $text;
          if (strpos($class,"_") > 0) { $class = substr($class,0,strrpos($class,"_")); }
          preg_match_all('/<rdg type="tag" n="f" corresp="#'.$id.'" resp="(.*?)"/',$xml,$matchAry,PREG_SET_ORDER);
          $tagCnt = count($matchAry);
          if ($tagCnt < 2) {
            if ($respCnt >= 2) { $class .= " tagSelected"; } else { $class .= " tagNotSelected"; }
            $p_text .= "<span id=\"$id\" class=\"$class\" title=\"$title\" onclick=\"parent.vetTag('$id');\" onmouseover=\"parent.highlightTag('$id');\" onmouseleave=\"parent.unHighlightTag('$id');\" >$txt</span>";
          } else {
            $tagAry[$id] = $tagCnt;
            for ($i = 1; $i <= $tagCnt; $i++) {
              $closingRespCnt = substr_count($matchAry[$tagCnt-$i][1],"#");
              if ($closingRespCnt >= 2) { $selected = "tagSelected"; } else { $selected = "tagNotSelected"; }
              $p_text .= "<span id=\"$id-$i\" class=\"$class $selected\" title=\"$title\" onclick=\"parent.vetTag('$id-$i');\" onmouseover=\"parent.highlightTag('$id-$i');\" onmouseleave=\"parent.unHighlightTag('$id-$i');\" >$txt</span>";
            }
          }
        }

        if (strpos($rdg,'type="tag" n="f"') !== false) {
          preg_match('/ resp="(.*?)"/',$rdg,$respsAry);
          $resps = $respsAry[1];
          $respCnt = count(split(' ',$respsAry[1]));
          preg_match('/">(.*?)<\/rdg>/',$rdg,$textsAry);
          $text = $textsAry[1];
          preg_match('/corresp="#(.*?)"/',$rdg,$idAry);
          $id = $idAry[1];
          $title = $text;
          $title = str_replace('_',' ',$title);
          $title = str_replace('::',"=''",$title);
          $title = str_replace(':',"''",$title);
          $class = $text;
          if (strpos($class,"_") > 0) { $class = substr($class,0,strrpos($class,"_")); }
          if ($respCnt >= 2) { $class .= " tagSelected"; } else { $class .= " tagNotSelected"; }
          $txt = "&#187;";
          $txt = "&rsaquo;";
          $i=0;
          if (isset($tagAry[$id])) {
            $i = $tagAry[$id];
            $tagAry[$id] = $i - 1;
            if ($i > 0) { $id .= "-$i"; }
          }
          $p_text .= "<span id=\".$id\" class=\"$class\" title=\"$title\" onclick=\"parent.vetTag('$id');\" onmouseover=\"parent.highlightTag('$id');\" onmouseleave=\"parent.unHighlightTag('$id');\" >$txt</span>";
        }
      }
    }

    if ($wordText) {
      if (count($wordOptions) == 1) { $class = "wordAgreement"; } else { $class = "wordDisagreement"; }
      $title = join(" | ",$wordOptions);
      $title = str_replace('"','&quot;',$title);
      $p_text .= "<span id=\"word_$wIdx\" class=\"$class\" title=\"$title\" onclick=\"vetMenu(this,event);\">$displayText</span>";
      $wordText = "";
      $wordOptions = array();
      $displayOptions = "";
      $wordResps = 0;
    }

    $needSpace = 1;
  }
  $p_text .= "<br>";
}


$text = $p_text;
$text = str_replace(chr(10),"",$text);
$text = str_replace(chr(13),"<br>",$text);

$p_text = "";

$vet = $p_witness;
if (substr($vet,0,4) != "Vet-") { $vet = "Vet-$vet"; }
$isComplete = $x->getDromioStatus("arbitration",$vet,$sfcid);

header('Content-Type:text/html; charset=UTF-8');
?>

<!DOCTYPE html>
<html xml:lang="en">
<head>
<title><?php echo "$work_title" ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style type="text/css" media="screen,print">@import "dromio.css";</style>
<style type="text/css" media="screen,print">@import "dromioTagging.css";</style>
<script type="text/javascript" src="FloatingBoxClass.js"></script>
<script type="text/javascript" src="FloatingTranscriptionClass.js"></script>
<script type="text/javascript">
  window.onbeforeunload = function () { 
    var saveBtn = document.getElementById("saveBtn");
    if (saveBtn && saveBtn.className.indexOf("redFG") > -1) {
      return 'Are you sure you want to leave without saving?'; 
    }
  }

<?php 
$text = str_replace("style=\"white-space:pre\"&amp;gt;","",$text);
  echo "  var savedText = `$text`;\n"; 
  echo "  var txt = `$text`;\n"; 
  if (count($isComplete) > 0) {
    echo "  var status = \"completed\";";
  } else {
    echo "  var status = \"\";";
  }
  echo "  var img = \"$p_page\";\n"; 
?>

  var box;
  var codeFormat = "html";
  var codeBtn;
  var saveBtn;

function addTranscriptionBox() {
  document.onclick = function() { document.getElementById('menu').style.display = "none"; }
  box = new FloatingTranscription(txt);
  box.transcriptionFrame.oninput = detectChange;
  box.transcriptionFrame.contentEditable = false;

<?php

  $toolbarAry = array();
  foreach ($toolbars as $toolbar) {
    if ($toolbar["type"] == "arbitration") {
      $id = $toolbar["id"];
      $display = $toolbar["display"];
      $checked = "";
      if ($display == "true") { $checked = "checked"; }
      echo "  box.addToolbar(\"$id\",\"$display\");\n";
      echo "  document.getElementById('selectToolbarsDiv').innerHTML += \"&nbsp;&nbsp;<input type='checkbox' id='show_$id' $checked onclick=\\\"box.selectToolbar('$id');\\\"/><span>$id</span><br/>\";\n";
      $toolbarAry[] = $id;
    }

  }
  foreach ($buttons as $button) {
    if (array_key_exists("toolbar",$button)) { $toolbar = $button["toolbar"]; } else { $toolbar = ""; }
    if (!in_array($toolbar,$toolbarAry)) { continue; }
    if (array_key_exists("id",$button)) { $id = $button["id"]; } else { $id = ""; }
    if (array_key_exists("type",$button)) { $type = $button["type"]; } else { $type = ""; }
    if (array_key_exists("label",$button)) { $label = $button["label"]; } else { $label = ""; }
    if (array_key_exists("title",$button)) { $title = $button["title"]; } else { $title = ""; }
    if (array_key_exists("function",$button)) { $function = $button["function"]; } else { $function = ""; }
    if (array_key_exists("style",$button)) { $style = $button["style"]; } else { $style = ""; }
    if (array_key_exists("class",$button)) { $class = $button["class"]; } else { $class = ""; }
    if ($type == "padding") {
      echo "  box.addToolbarPadding(\"$toolbar\",\"$class\");\n";
    } else {
      echo "  box.addToolbarButton(\"$toolbar\",\"$id\",\"$type\",\"$label\",\"$title\",\"$function\",\"$class\");\n";
    }
  }
?>
  if (status && document.getElementById('completeBtn')) {
    document.getElementById('completeBtn').className += " redBG";
  }
  if (document.getElementById('codeBtn')) { codeBtn = document.getElementById('codeBtn'); }
  if (document.getElementById('saveBtn')) { saveBtn = document.getElementById('saveBtn'); }
  savedText = getCode(box.transcriptionFrame.innerHTML,"xml");

  box.transcriptionFrame.focus();

  if (!img) {
    document.getElementById("imgHolder").style.display = "none";
    document.getElementById("imgControls").style.display = "none";
    box.size={width:.96*window.innerWidth,height:window.innerHeight-50};
    box.position={left:.02*window.innerWidth,top:50};
  } else {
    var width = Math.min(.5*window.innerWidth,500);
    var left = (window.innerWidth - width) /2;
    box.size={width:width,height:250};
    box.position={left:left,top:window.innerHeight-300};

    zoomFactor = 1;
    var rotateFactor = 0;
    document.getElementById("rotateLbl").value = rotateFactor;

    var imgElement = document.getElementById("image1");

    //auto-zoom image
    if (zoomFactor != 1) {  //if image has previously been resized
      var w = parseInt(imgElement.width) * zoomFactor;
      var h = parseInt(imgElement.height) * zoomFactor;
      imgElement.width = w;
      imgElement.height = h;
    } else {  //resize to fit browser window
      zoomFactor = (window.innerWidth / imgElement.width);
      zoomFactor = zoomFactor * .94;
      var w = parseInt(imgElement.width) * zoomFactor;
      var h = parseInt(imgElement.height) * zoomFactor;
      imgElement.width = w;
      imgElement.height = h;
    }

    document.getElementById("magnifyPct").innerHTML = parseInt(zoomFactor * 100) + "%";
  }
}
function zoomIn() {
  img = document.getElementById("image1");
  if (img) {
    var w = parseInt(this.img.width) * 1.1;
    var h = parseInt(this.img.height) * 1.1;
    this.img.width = w;
    this.img.height = h;
    zoomFactor = zoomFactor * 1.1;
    this.magnifyPct.innerHTML = parseInt(zoomFactor * 100) + "%";
  }
}
function zoomOut() {
  img = document.getElementById("image1");
  if (img) {
    var w = parseInt(this.img.width) / 1.1;
    var h = parseInt(this.img.height) / 1.1;
    this.img.width = w;
    this.img.height = h;
    zoomFactor = zoomFactor / 1.1;
    this.magnifyPct.innerHTML = parseInt(zoomFactor * 100) + "%";
  }
}

function rotate(r) {
  img = document.getElementById("image1");
  r = parseInt(r);
  if (!r) { r = 0; }
  if (!document.getElementById("rotateLbl").value) { document.getElementById("rotateLbl").value = 0; }
  if (img) {
    var deg = parseInt(document.getElementById("rotateLbl").value) + r;
    while (deg < 0) { deg += 360; }
    while (deg > 360) { deg -= 360; }
    img.style.transform = "rotate("+deg+"deg)";
    img.style.webkitTransform = "rotate("+deg+"deg)";
    var rad = deg * Math.PI / 180;
    var w = Math.cos(rad) * img.width + Math.sin(rad) * img.height;
    var h = Math.cos(rad) * img.height + Math.sin(rad) * img.width;
    img.top="0px";
    img.left="0px";
    img.style.position="relative";
    img.style.left=(Math.abs(w)-img.width)/2+"px";
    img.style.top=(Math.abs(h)-img.height)/2+"px";
    document.getElementById("rotateLbl").value = deg;
  }
}

  function getCode(text,outFormat) {
    var textSpan = document.createElement("dromioroot");
    var format = codeFormat;
    if (outFormat == "xml" && codeFormat == "xml") { format = ""; }

    if (format == "html") {
      textSpan.innerHTML = text;
      text = getText(textSpan,'xml');
      text = text.replace(/\u200B/g,"");
      text = text.replace(/<br\//g,"<lb/");
      text = text.replace(/<br>/g,"<lb/>");
      text = text.replace(/</g,"&lt;");
      text = text.replace(/>/g,"&gt;");
      text = text.replace(/&lt;lb.?&gt;/g,"<br/>&lt;lb/&gt;");
      text = "&lt;lb/&gt;"+text;
    } else if (format == "xml") {
      text = text.replace(/^\&lt;lb.?\&gt;/,"");
      text = text.replace(/<.?br.?>/g,"");
      text = text.replace(/\&lt;/g,"<");
      text = text.replace(/\&gt;/g,">");
      text = text.replace(/<lb/g,"<br");
      textSpan.innerHTML = text;
      text = getText(textSpan,'html');
    }
    if (outFormat == "xml") {
      text = text.replace(/\&lt;/g,"<");
      text = text.replace(/\&gt;/g,">");
      text = text.replace(/<.?br.?>/g,"");
      text = text.replace(/\&/g,"&amp;");
    }
    return text;
  }
    
  function getText(x,code) {
    var text = "";
    if (x.childNodes) {
      for (var i=0; i<x.childNodes.length; i++) { text += getText(x.childNodes[i],code);}
    }
    if (x.nodeName == 'BODY') {
    } else if (x.nodeName == '#text') {
      text = x.nodeValue;
    } else if (x.nodeName == 'DIV') {
//      text = "<br/>"+text;
    } else if (x.nodeName == 'P') {
      text = text+"<br/>";
    } else if (x.nodeName == 'BR') {
      text = "<br/>";
    } else if (x.nodeName == 'LB') {
    } else if (x.nodeName == 'DROMIOROOT') {
    } else if (code == 'html') {
      att="";
      for (i=0;i<x.attributes.length;i++) { 
        att += " "+x.attributes[i].name+"=\""+x.attributes[i].value+"\""; 
      }
      text = '<span class="'+x.nodeName.toLowerCase()+'" title="'+x.nodeName+'"'+att+'>'+text+'</span>\u200B';
    } else if (code == 'xml') {
      if (x.nodeName == 'SPAN') {
        if (x.getAttribute('id')) {
          var spanId = x.getAttribute('id');
          if (spanId.indexOf("word_") == -1) {
            var spanClass = x.getAttribute('class');
            if (spanClass.indexOf("tagSelected") > -1) {
              var tag = spanId.replace(/^\./,"/");
              tag = tag.substring(0,tag.indexOf('-'));
              text = '<'+tag+'>';
            } else {
              //unselected tag
              text = "";
            }
          }
        } else {
          att="";
          for (i=0;i<x.attributes.length;i++) { 
            if (x.attributes[i].name == "class") {
            } else if (x.attributes[i].name == "title") {
            } else {
              att += " "+x.attributes[i].name+"=\""+x.attributes[i].value+"\""; 
            }
          }
          if (x.getAttribute('class')) {
            var tag = x.getAttribute('class').toLowerCase();
            text = '<'+tag+att+'>'+text+'</'+tag+'>';
          }
        }
      }
    }
    return text;
  }

  function saveTranscription() {
    if (document.getElementById('saveBtn').className.indexOf("redBG") == -1) {
      document.getElementById('saveBtn').className += " redBG";
    }
    var transcription = getCode(box.transcriptionFrame.innerHTML,"xml");
    transcription = transcription.replace(/^<lb\/>/,"");
    transcription = transcription.replace(/\s+/g," ");
    transcription = transcription.replace(/\s*<lb\/>\s*/g,"<lb/>");

    try {
      var parser = new DOMParser();
      var validateXML = parser.parseFromString("<xml>"+transcription+"</xml>", "text/xml");
    } catch (e) {
      alert(e.message);
      return false;
    }
    if (validateXML.documentElement.nodeName == "parsererror") {
      var xmlString = (new XMLSerializer()).serializeToString(validateXML.documentElement);
      alert("Cannot save document. XML is not well-formed.");
console.log(xmlString);
      return false;
    }

    var saveForm = new FormData();

    var statusStr = "";
    if (status == "completed") { statusStr = "arbitration"; }
<?php
  echo "    saveForm.append(\"document\",\"$p_id\");\n";
  echo "    saveForm.append(\"surface\",\"$sfcid\");\n";
  echo "    saveForm.append(\"witness\",\"$vetWitness\");\n";
  echo "    saveForm.append(\"transcription\",transcription);\n";
  echo "    saveForm.append(\"status\",statusStr);\n";
?>
    var request = new XMLHttpRequest();
    request.onload = function() { 
      if (this.status == "200" && this.response == "Success") {
        document.getElementById('saveBtn').className = saveBtn.className.replace(/[ ]?redBG/,"");
        txt = box.transcriptionFrame.innerHTML;
        savedText = getCode(box.transcriptionFrame.innerHTML,"xml");
        detectChange();
        box.transcriptionFrame.focus();
      } else {
        alert("Error saving the file");
        console.log(request.response);
      }
    };
    request.onerror = function() { console.log('ERROR','saveTranscription',this.status); };
    request.open("POST","saveTranscription.php");
    request.send(saveForm);
  }
  function completeTranscription() {
    status = "completed";
    document.getElementById('completeBtn').className += " redBG";
    saveTranscription();
  }


function detectChange() {
  saveBtn = document.getElementById("saveBtn");
  var transcription = getCode(box.transcriptionFrame.innerHTML,"xml");

  if (transcription != savedText) {
    if (saveBtn.className.indexOf("redFG") == -1) {
      saveBtn.className += " redFG";
      return true;
    }
  } else {
    saveBtn.className = saveBtn.className.replace(/[ ]?redFG/,"");
    return false;
  }
}

function resizeImgHolder() { return true; }

function selectToolbars() {
  document.getElementById('selectToolbarsDiv').style.display='block';
}

document.ongesturestart=new Function("event.preventDefault();");
document.ongesturechange=new Function("event.preventDefault();");
window.onresize=resizeImgHolder;
</script>

<style type="text/css">
  @media screen {
	.transcribe { height: 40%; overflow:auto }
        .print { display:none }
}
  @media print {
        .xoprint { display:none }
        .noprint { visibility: hidden; }
	.transcribe { height: auto; overflow:visible }
.transcriptionFrame {
  visibility: visible;
  display: block;
  position: absolute;
  top: 50px;
  left: 10px;
  width: auto;
  height: auto;
  background-color: white;
  padding: 10px;
}
  }
</style>
<script type="text/javascript">
function exclude() {
  var id = "<?php echo $p_id; ?>";
  var sfcid = "<?php echo $sfcid; ?>";
  var wid = "<?php echo $p_witness; ?>";
  var exclude = "";
  var x = document.getElementsByTagName("input");
  for (i = 0; i < x.length; i++) {
    if (x[i].id.substring(0,8) == "exclude_") {
      if (x[i].checked) {
        if (exclude.length) { exclude += ";"; }
        var resp = x[i].id.substr(8);
        exclude += resp;
      }
    }
  }
  var url = "http://"+window.location.hostname+window.location.pathname;
  url += "?id="+id;
  url += "&sfcid="+sfcid;
  url += "&wid="+wid;
  if (exclude.length) {
    url += "&exclude="+exclude;
  }
  window.location.assign(url);
}
</script>
<script type="text/javascript">
function vetMenu(obj,event) {
  setMenu(obj);
  if (obj.title) {
    var title = encodeTags(obj.title);
    var current = encodeTags(obj.innerHTML);
    var encodedOptions = [];
    var options = title.split(" | ");
    for (var i=0; i < options.length; i++) {
      var option = options[i];
      option = option.replace(/"/g,"&quot;");
      menu.innerHTML += "<span class=\"option\" onclick=\"vetWord('"+obj.id+"','"+option+"');\">"+options[i]+"</span><br/>";
      encodedOptions.push(convertXMLtoHTML(option));
    }
    if (encodedOptions.indexOf(current) == -1) {
      menu.innerHTML += "<span class=\"option\" onclick=\"vetWord('"+obj.id+"','"+current+"');\">"+current+"</span><br/>";
    }
  }
  var menuText = "";
  menuText += "&#8203;<span id=\"newOption\">";
  menuText += "<span id=\"editNewOption\" class=\"newOption\" contenteditable=\"true\" onclick=\"editOption('"+obj.id+"',`"+current+"`,event);\" >[Edit Word]</span>";
  menuText += "<span id=\"saveOption\" class=\"newOption\"  style=\"display: none;\" onclick=\"vetWord('"+obj.id+"',document.getElementById('editNewOption').innerHTML);\" >&#10004;</span>";
  menuText += "</span>";
  menu.innerHTML += menuText;
  menu.style.display = "block";
  event.stopPropagation();
}
function encodeTags(str) {
  str = str.replace(/</g,"&lt;");
  str = str.replace(/>/g,"&gt;");
  return str;
}
function vetWord(id,word) {
  var obj = document.getElementById(id);
  if (obj.title) {
    //var title = encodeTags(obj.title);
    var title = obj.title;
    var options = title.split(" | ");
    if (options.indexOf(word) == -1) {
      obj.title += " | "+word;
    }
  }
  word = word.replace(/\&lt;/g,"<");
  word = word.replace(/\&gt;/g,">");
  word = word.replace(/<(.*?)>/g,"<span class=\"$1\">");
  word = word.replace(/<span class="\/.*?">/g,"</span>");
  obj.innerHTML = word;
  obj.className = 'wordVetted';
  document.getElementById('menu').style.display="none";
  detectChange();
}
function convertXMLtoHTML(word) {
  word = word.replace(/\&lt;/g,"<");
  word = word.replace(/\&gt;/g,">");
  word = word.replace(/<(.*?)>/g,"<span class=\"$1\">");
  word = word.replace(/<span class="\/.*?">/g,"</span>");
  word = word.replace(/</g,"&lt;");
  word = word.replace(/>/g,"&gt;");
  word = word.replace(/&quot;/g,'"');
  return word;
}
function editOption(objid,word,event) {
  document.getElementById('editNewOption').onclick = null;
  document.getElementById('editNewOption').textContent = word;
  document.getElementById('saveOption').style.display = "inline-block";
  document.getElementById('newOption').className = "border";
  event.stopPropagation();
}
function setMenu(obj) {
  var pos = obj.getBoundingClientRect();
  var menu = document.getElementById('menu');
  menu.style.top = (pos.bottom) + "px";
  menu.style.left = (pos.right) + "px";
  menu.innerHTML = "";
}
function highlightTag(tagId) {
  var tagS = document.getElementById(tagId);
  var tagE = document.getElementById('.'+tagId);
  tagS.className += " highlightTag";
  tagE.className += " highlightTag";
}
function unHighlightTag(tagId) {
  var tagS = document.getElementById(tagId);
  var tagE = document.getElementById('.'+tagId);
  tagS.className = tagS.className.replace(/ highlightTag/,'');
  tagE.className = tagE.className.replace(/ highlightTag/,'');
}
function vetTag(tagId) {
  var tagS = document.getElementById(tagId);
  var tagE = document.getElementById('.'+tagId);
  if (tagS.className.indexOf('tagSelected') == -1) {
    tagS.className = tagS.className.replace(/ tagNotSelected/,'');
    tagE.className = tagE.className.replace(/ tagNotSelected/,'');
    tagS.className += " tagSelected";
    tagE.className += " tagSelected";
  } else {
    tagS.className = tagS.className.replace(/ tagSelected/,'');
    tagE.className = tagE.className.replace(/ tagSelected/,'');
    tagS.className += " tagNotSelected";
    tagE.className += " tagNotSelected";
  }
  detectChange();
}
</script>

</head>

<body class="transcriptionBody" onload="addTranscriptionBox();">
<div id="menu" class="menu" style="display:none;" onclick="event.stopPropagation();"></div>
<div id="transcriptionHeader">
  <div id="imgControls" class="noprint">
    <div id="magnifyLabel" class="label">Zoom: </div>
    <input type="button" id="demagnify" value="<" onclick="zoomOut();"/>
    <div id="magnifyPct"></div>
    <input type="button" id="magnify" value=">" onclick="zoomIn();"/>

    <br/>
    <div id="rotateLabel" class="label">Rotate:</div>
    <input type="button" id="rotateL" value="<" onclick="rotate(-90);"/>
    <input id="rotateLbl" maxlength="3" onkeyup="rotate();">
    <input type="button" id="rotateR" value=">" onclick="rotate(90);"/>
  </div>


  <div class="fontBig right"><?php echo "$p_witness: "; ?><span class="noprint"><a href="<?php echo "$rtndir"; ?>">Return to Work</a></span>
  <br/>
  <button onclick="document.getElementById('excludeOptions').style.display='block';">Exclude Transcriptions</button>
  </div>

  <div class="transcriptionTitle"><b><?php echo "$work_title"; ?></b></div>
  <div id="imgHolder" class="noprint">
    <img id="image1" src="<?php echo "$p_page"; ?>" style="user-select: none;" ondragstart="return false;" alt=""/>
  </div>
</div>


<div id="selectToolbarsDiv">
Toolbars:<br/>
<span id="selectToolbarsSpan"></span>
<p style="text-align:center"><input type="button" id="closeTB" value="Close" onclick="document.getElementById('selectToolbarsDiv').style.display='none';" /></p>
</div>
<div id="excludeOptions">
<div style="float:right;"><input type="button" id="closeOptions" value="Close" onclick="document.getElementById('excludeOptions').style.display='none';" /></div>
<div id="tabOptions">Exclude:<br/>
<?php
  foreach ($respAry as $resp) {
    $checked = "";
    if (in_array($resp,$excludeAry)) { $checked = "checked"; }
    echo "<input type=\"checkbox\" id=\"exclude_$resp\" $checked/>$resp<br/>\n";
  }
?>
<p style="text-align:center">
<input type="button" id="closeOptions" value="Exclude Transcriptions" onclick="exclude()" />
<br/><b>Warning:</b> the page will be refreshed,<br/>and any changes will be lost.
</p>
</div>
</div>

</body>
</html>
