<?php
  include "dromio_config.php";
?>
<!DOCTYPE html>
<html xml:lang="en">
<head>
<title>Dromio - Folger Shakespeare Library</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style type="text/css" media="screen,print">@import "dromio.css";</style>
<script type="text/javascript">
  function addRow(id) {
    var key = id.substring(0,id.indexOf('-'));
    var idx = id.substring(id.indexOf('-')+1);
    var div = document.getElementById("addRow-"+key);
    var str = div.innerHTML;
    str = str.replace(/idx/g,parseInt(idx)+1);
    str = str.replace(/>\* /,">");
    str = str.replace(/ required/g,"");
    document.getElementById("btn-"+id).innerHTML = "&nbsp;";
    div.outerHTML = str+"\n"+div.outerHTML
  }
</script>
</head>
<body>
  <a id="logo" href="<?php echo $base_url; ?>"></a>
<?php

if (array_key_exists('submit',$_POST) && $_POST['submit'] == "Save") {
  if (!isset($id) && isset($_POST['id'])) { $id = $_POST['id']; }
  if (!isset($level) && isset($_POST['level'])) { $level = $_POST['level']; }
  if ($dir) { $id = "$dir/$id"; }
  include "updateWork.php";
} else {
  $id = "";
  if (isset($_GET['id'])) {
    $id = $_GET['id'];
  }
  $level = "work";
  if (isset($_GET['level'])) {
    $level = $_GET['level'];
  }
  $levelAry = "$level"."Ary";
  $editAry = $$levelAry;
  $x = new DromioDocument($id);
}
$p_id = $id;
if ($x->getMsg('error')) {
  echo "<p class=\"message\">".$x->getMsg('error')."</p>\n";
}
if ($x->getMsg('warning')) {
  echo "<p>".$x->getMsg('warning')."</p>\n";
}
$action = "editWork.php?".$_SERVER['QUERY_STRING'];
?>
  <div id="contentsDiv">
  <form id="newform" method="post" enctype="multipart/form-data" action="<?php echo "$action"; ?>">
    <input type="hidden" name="p_id" value="<?php echo "$id"; ?>"/>
    <input type="hidden" name="id" value="<?php echo "$id"; ?>"/>
    <input type="hidden" name="dir" value="<?php echo "$dir"; ?>"/>
    <input type="hidden" name="level" value="<?php echo "$level"; ?>"/>
<?php
  foreach ($_GET as $key=>$value) {
    if ($key == "id") {
    } elseif ($key == "level") {
    } elseif ($key == "dir") {
    } else {
      echo "    <input type=\"hidden\" name=\"$key\" value=\"$value\"/>\n";
    }
  }
?>
    <div class="contentsHeader">
      <div class="contentsText">
<?php 
 if ($p_id) { 
   $rtndir = "viewWork.php?id=$p_id";
   echo "<a class=\"inherit\" href=\"$rtndir\" title=\"Return to Work\">&#9668;</a>&nbsp;$p_id\n";
  } else {
    $rtndir = "index.php";
    if ($dir) { $rtndir .= "?dir=$dir"; }
    echo "<a class=\"inherit\" href=\"$rtndir\" title=\"Return to Main Page\">&#9668;</a>&nbsp;[New File]\n";
  }
?>
      </div>
    </div>


<?php

try {
foreach ($editAry as $w) {
  $path = $w->getPath();
  $value = "";
  $addRow = false;
  if (preg_match_all('/\$(\w*)/',$path,$matches)) {
    foreach ($matches as $match) {
      foreach ($match as $var) {
        $val = "";
        if (array_key_exists($var,$_GET)) { $val = $_GET[$var]; }
        elseif (array_key_exists($var,$_POST)) { $val = $_POST[$var]; }
        elseif (array_key_exists($var."-0",$_POST)) { $val = $_POST[$var."-0"]; }
        if (substr($var,-4) != "List") {
          $path = str_replace("$".$var,$val,$path);
        }
      }
    }
  }
  if (preg_match('/\$(\w*List)/',$path,$matches)) {
    $list = ${$matches[1]};
    $valExists = false;
    $n=0;

    $count = 0;
    foreach ($list as $l) {
      $lpath = preg_replace('/\$\w*List/',$l,$path);
      $value = $x->getValue($lpath);
      $count += count($value);
    }

    foreach ($list as $l) {
      $lpath = preg_replace('/\$\w*List/',$l,$path);
      $value = $x->getValue($lpath);
      if ($value) {
        $valExists = true;
        foreach ($value as $val) {
          if ($count == $n+1) { $addRow = true; } else { $addRow = false; }
          echo "      <input name=\"prev".$w->id."-$n\" type=\"hidden\" value=\"$l\"/>\n";
          $w->writeLine($val,$n,$addRow,$l);
          $n++;
        }
      }
    }
    if ($valExists === false) {
      $w->writeLine();
      $addRow = true;
    }
  } elseif ($w->input == "file") {
      $w->writeLine();
      $addRow = false;
  } else {
    $value = $x->getValue($path);
    if ($value) {
      $n=0;
      foreach ($value as $val) {
        if (count($value) == $n+1) { $addRow = true; } else { $addRow = false; }
        $w->writeLine($val,$n,$addRow);
        $n++;
      }
    } else {
      $w->writeLine();
      $addRow = true;
    }
  }
  if ($addRow && !($w->isSingleton())) {
    echo "      <div id=\"addRow-".$w->id."\" style=\"display:none;\">\n";
    $w->writeLine("","idx",true);
    echo "      </div>\n";
  }
}
} catch (Exception $e) {
  echo "<p>Error: $e</p>\n";
}

?>
<div class="contentsRow row1" id="submit">
  <input type="submit" name="submit" class="button" value="Save"/>
</div>
<div class="contentsRow row1" id="return">
  <br/>
  <a class="blue" href="<?php echo "$rtndir"; ?>">Return to Work</a>
</div>

  </form>

  </div>

</body>
</html>
