﻿<?php
setlocale(LC_ALL, 'en_US.UTF8');
header('Content-Type:text/html; charset=UTF-8');
header('X-XSS-Protection:0');

include "dromio_config.php";
$rtndir = "index.php";
  
if (isset($_GET["id"])) {
  $p_id = $_GET["id"];
} else {
  header("Location: $rtndir");
  exit;
}

$rtndir = "viewWork.php?id=$p_id";
if (isset($_GET["sfcid"])) {
  $sfcid = $_GET["sfcid"];
} else {
  header("Location: $rtndir");
  exit;
}

if (isset($_GET["wid"])) {
  $p_witness = $_GET["wid"];
} else if (isset($_COOKIE['folger_cookie'])) {
   $disp_name = $_COOKIE['folger_cookie'];
   $p_name = str_replace("'","''",$_COOKIE['folger_cookie']);
   $p_name = str_replace("\"","",$p_name);
   $p_name = str_replace(" ","",$p_name);
   $p_witness = $p_name;
} else {
  header("Location: $rtndir");
  exit;
}
setcookie ("folger_cookie",$p_witness, time()+60*60*24*7);
$p_witness = preg_replace('/[^a-zA-Z0-9\:\-\_\.]/','',$p_witness);


$x = new DromioDocument($p_id);
$p_page = "";
$pageAry = $x->getValue("//TEI:surface[@xml:id='$sfcid']/TEI:media/@url");
if (count($pageAry)) { $p_page = $pageAry[0]; }

if (isset($_POST["transcription"])) {
 $p_text = str_replace("\"","&#34;",$p_text);
}

$work_title = $x->getTitle();
$surfaceAry = $x->getSurfaces();
foreach ($surfaceAry as $surface => $n) {
 if ($n && $surface == $sfcid) { $work_title .=": $n"; }
}
$title = "";

$witnessesAry = array();

$p_text = "";

$p_text = $x->getDromioLines($sfcid,$p_witness);
$p_text = $x->getDromioTranscription($sfcid,$p_witness);
$p_text = str_replace('"','\"',$p_text);

$p_text = str_replace("&amp;","&",$p_text);
$p_text = str_replace("&lt;","<",$p_text);
$p_text = str_replace("&gt;",">",$p_text);

$text = $p_text;
$text = str_replace(chr(10),"",$text);
$text = str_replace(chr(13),"<br>",$text);

$isComplete = $x->getDromioStatus("draft",$p_witness,$sfcid);

$print_text = $p_text;
$print_text = str_replace("<ex>","<i>",$print_text);
$print_text = str_replace("</ex>","</i>",$print_text);
$print_text = str_replace("<supplied>","[",$print_text);
$print_text = str_replace("</supplied>","]",$print_text);
$print_text = str_replace("<brev-y>","<i>",$print_text);
$print_text = str_replace("</brev-y>","</i>",$print_text);
$print_text = str_replace("<brev-es>","<i>",$print_text);
$print_text = str_replace("</brev-es>","</i>",$print_text);
$print_text = str_replace("<brev-er>","<i>",$print_text);
$print_text = str_replace("</brev-er>","</i>",$print_text);
$print_text = str_replace("<gap>","[",$print_text);
$print_text = str_replace("</gap>","]",$print_text);

$i = 0;

header('Content-Type:text/html; charset=UTF-8');
?>

<!DOCTYPE html>
<html xml:lang="en">
<head>
<title><?php echo "$work_title" ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style type="text/css" media="screen,print">@import "dromio.css";</style>
<style type="text/css" media="screen,print">@import "dromioTagging.css";</style>
<script type="text/javascript" src="FloatingBoxClass.js"></script>
<script type="text/javascript" src="FloatingTranscriptionClass.js"></script>
<script type="text/javascript">
  window.onbeforeunload = function () { 
    var saveBtn = document.getElementById("saveBtn");
    if (saveBtn && saveBtn.className.indexOf("redFG") > -1) {
      return 'Are you sure you want to leave without saving?'; 
    }
  }

<?php 
  echo "  var savedText = \"$text\";\n"; 
  echo "  var txt = `$text`;\n"; 
  if (count($isComplete) > 0) {
    echo "  var status = \"completed\";";
  } else {
    echo "  var status = \"\";";
  }
  echo "  var img = \"$p_page\";\n"; 
?>

  var box;
  var codeFormat = "xml";
  var codeBtn;
  var saveBtn;

function pasteTranscription(event) {
  var text = event.clipboardData.getData('Text');
  var range = window.getSelection().getRangeAt(0);
  range.deleteContents();

  textAry = text.split("\n");
  for (var i = textAry.length-1; i >= 0; i--) { 
    range.insertNode(document.createTextNode(textAry[i]));
    if (i > 0) {
      range.insertNode(document.createElement("br"));
    }
  }
  range.collapse();

  event.preventDefault();
}
function addTranscriptionBox() {
  txt = getCode(txt,"xml");
  box = new FloatingTranscription(txt);
  box.transcriptionFrame.oninput = detectChange;
  box.transcriptionFrame.onpaste = pasteTranscription;

<?php

  $toolbarAry = array();
  foreach ($toolbars as $toolbar) {
    if ($toolbar["type"] == "transcription") {
      $id = $toolbar["id"];
      $label = $toolbar["label"];
      $display = $toolbar["display"];
      $required = $toolbar["required"];
      $checked = "";
      $disabled = "";
      if ($display == "true") { $checked = "checked"; }
      if ($required == "true") { $disabled = "disabled"; }
      echo "  box.addToolbar(\"$id\",\"$display\");\n";
      echo "  document.getElementById('selectToolbarsSpan').innerHTML += \"&nbsp;&nbsp;<input type='checkbox' id='show_$id' $checked $disabled onclick=\\\"box.selectToolbar('$id');\\\"/><span>$label</span><br/>\";\n";
      $toolbarAry[] = $id;
    }

  }
  foreach ($buttons as $button) {
    if (array_key_exists("toolbar",$button)) { $toolbar = $button["toolbar"]; } else { $toolbar = ""; }
    if (!in_array($toolbar,$toolbarAry)) { continue; }
    if (array_key_exists("id",$button)) { $id = $button["id"]; } else { $id = ""; }
    if (array_key_exists("type",$button)) { $type = $button["type"]; } else { $type = ""; }
    if (array_key_exists("label",$button)) { $label = $button["label"]; } else { $label = ""; }
    if (array_key_exists("title",$button)) { $title = $button["title"]; } else { $title = ""; }
    if (array_key_exists("function",$button)) { $function = $button["function"]; } else { $function = ""; }
    if (array_key_exists("style",$button)) { $style = $button["style"]; } else { $style = ""; }
    if (array_key_exists("class",$button)) { $class = $button["class"]; } else { $class = ""; }
    if ($type == "padding") {
      echo "  box.addToolbarPadding(\"$toolbar\",\"$class\");\n";
    } else {
      echo "  box.addToolbarButton(\"$toolbar\",\"$id\",\"$type\",\"$label\",\"$title\",\"$function\",\"$class\");\n";
    }
  }
?>
  if (status && document.getElementById('completeBtn')) {
    document.getElementById('completeBtn').className += " redBG";
  }
  if (document.getElementById('codeBtn')) { codeBtn = document.getElementById('codeBtn'); }
  if (document.getElementById('saveBtn')) { saveBtn = document.getElementById('saveBtn'); }
  showCode();
  savedText = getCode(box.transcriptionFrame.innerHTML,"xml");

  box.transcriptionFrame.focus();

  if (!img) {
    document.getElementById("imgHolder").style.display = "none";
    document.getElementById("imgControls").style.display = "none";
    box.size={width:.96*window.innerWidth,height:window.innerHeight-50};
    box.position={left:.02*window.innerWidth,top:50};
  } else {
    var width = Math.min(.5*window.innerWidth,500);
    var left = (window.innerWidth - width) /2;
    box.size={width:width,height:250};
    box.position={left:left,top:window.innerHeight-300};

    zoomFactor = 1;
    var rotateFactor = 0;
    document.getElementById("rotateLbl").value = rotateFactor;

    var imgElement = document.getElementById("image1");

    //auto-zoom image
    if (zoomFactor != 1) {  //if image has previously been resized
      var w = parseInt(imgElement.width) * zoomFactor;
      var h = parseInt(imgElement.height) * zoomFactor;
      imgElement.width = w;
      imgElement.height = h;
    } else {  //resize to fit browser window
      zoomFactor = (window.innerWidth / imgElement.width);
      zoomFactor = zoomFactor * .94;
      var w = parseInt(imgElement.width) * zoomFactor;
      var h = parseInt(imgElement.height) * zoomFactor;
      imgElement.width = w;
      imgElement.height = h;
    }

    document.getElementById("magnifyPct").innerHTML = parseInt(zoomFactor * 100) + "%";
  }
}
function zoomIn() {
  img = document.getElementById("image1");
  if (img) {
    var w = parseInt(this.img.width) * 1.1;
    var h = parseInt(this.img.height) * 1.1;
    this.img.width = w;
    this.img.height = h;
    zoomFactor = zoomFactor * 1.1;
    this.magnifyPct.innerHTML = parseInt(zoomFactor * 100) + "%";
  }
}
function zoomOut() {
  img = document.getElementById("image1");
  if (img) {
    var w = parseInt(this.img.width) / 1.1;
    var h = parseInt(this.img.height) / 1.1;
    this.img.width = w;
    this.img.height = h;
    zoomFactor = zoomFactor / 1.1;
    this.magnifyPct.innerHTML = parseInt(zoomFactor * 100) + "%";
  }
}

function rotate(r) {
  img = document.getElementById("image1");
  r = parseInt(r);
  if (!r) { r = 0; }
  if (!document.getElementById("rotateLbl").value) { document.getElementById("rotateLbl").value = 0; }
  if (img) {
    var deg = parseInt(document.getElementById("rotateLbl").value) + r;
    while (deg < 0) { deg += 360; }
    while (deg > 360) { deg -= 360; }
    img.style.transform = "rotate("+deg+"deg)";
    var rad = deg * Math.PI / 180;
    var w = Math.cos(rad) * img.width + Math.sin(rad) * img.height;
    var h = Math.cos(rad) * img.height + Math.sin(rad) * img.width;
    img.top="0px";
    img.left="0px";
    img.style.position="relative";
    img.style.left=(Math.abs(w)-img.width)/2+"px";
    img.style.top=(Math.abs(h)-img.height)/2+"px";
    document.getElementById("rotateLbl").value = deg;
  }
}

  function getCode(text,outFormat) {
    var textSpan = document.createElement("dromioroot");
    var format = codeFormat;
    if (outFormat == "xml" && codeFormat == "xml") { format = ""; }

    if (format == "html") {
      textSpan.innerHTML = text;
      text = getText(textSpan,'xml');
      text = text.replace(/\u200B/g,"");
      text = text.replace(/<br\//g,"<lb/");
      text = text.replace(/<br>/g,"<lb/>");
      text = text.replace(/</g,"&lt;");
      text = text.replace(/>/g,"&gt;");
      text = text.replace(/&lt;lb.?&gt;/g,"<br/>&lt;lb/&gt;");
      text = "&lt;lb/&gt;"+text;
    } else if (format == "xml") {
      text = text.replace(/^\&lt;lb.?\&gt;/,"");
      text = text.replace(/<.?br.?>/g,"");
      text = text.replace(/\&lt;/g,"<");
      text = text.replace(/\&gt;/g,">");
      text = text.replace(/<lb/g,"<br");
      textSpan.innerHTML = text;
      text = getText(textSpan,'html');
    }
    if (outFormat == "xml") {
      text = text.replace(/\&lt;/g,"<");
      text = text.replace(/\&gt;/g,">");
      text = text.replace(/<.?br.?>/g,"");
      text = text.replace(/\u00A0/g," ");
      text = text.replace(/\t/g," ");
      text = text.replace(/\&/g,"&amp;");
    }
    return text;
  }
  function showCode(txt) {
    var frame = box.transcriptionFrame;
    var btn = document.getElementById('codeBtn');
    var txt = "";
    txt = getCode(frame.innerHTML,"html");
    if (codeFormat == "html") {
      codeFormat = "xml";
      lbl = "HTML";
    } else if (codeFormat == "xml") {
      codeFormat = "html";
      lbl = "&lt;xml&gt;";
    }
    btn.innerHTML = lbl;
    frame.innerHTML = txt;
  }
    
  function getText(x,code) {
    var text = "";
    if (x.childNodes) {
      for (var i=0; i<x.childNodes.length; i++) { text += getText(x.childNodes[i],code);}
    }
    if (x.nodeName == 'BODY') {
    } else if (x.nodeName == '#text') {
      text = x.nodeValue;
    } else if (x.nodeName == 'DIV') {
      text = "<br/>"+text;
    } else if (x.nodeName == 'P') {
      text = text+"<br/>";
    } else if (x.nodeName == 'BR') {
      text = "<br/>";
    } else if (x.nodeName == 'LB') {
    } else if (x.nodeName == 'DROMIOROOT') {
    } else if (x.nodeName == 'APPLE-TAB-SPAN') {
    } else if (code == 'html') {
      att="";
      for (i=0;i<x.attributes.length;i++) { 
        att += " "+x.attributes[i].name+"=\""+x.attributes[i].value+"\""; 
      }
      text = '<span class="'+x.nodeName.toLowerCase()+'" title="'+x.nodeName+'"'+att+'>'+text+'</span>\u200B';
    } else if (code == 'xml') {
      if (x.nodeName == 'APPLE-TAB-SPAN') {
      } else if (x.nodeName == 'SPAN') {
        att="";
        for (i=0;i<x.attributes.length;i++) { 
          if (x.attributes[i].name == "class") {
          } else if (x.attributes[i].name == "title") {
          } else if (x.attributes[i].name == "style") {
          } else {
            att += " "+x.attributes[i].name+"=\""+x.attributes[i].value+"\""; 
          }
        }
        if (x.getAttribute('class')) {
          var tag = x.getAttribute('class').toLowerCase();
          text = '<'+tag+att+'>'+text+'</'+tag+'>';
        }
      }
    }
    return text;
  }

  function saveTranscription() {
    if (document.getElementById('saveBtn').className.indexOf("redBG") == -1) {
      document.getElementById('saveBtn').className += " redBG";
    }
    var transcription = getCode(box.transcriptionFrame.innerHTML,"xml");
    transcription = transcription.replace(/^<lb\/>/,"");

    try {
      var parser = new DOMParser();
      var validateXML = parser.parseFromString("<xml>"+transcription+"</xml>", "text/xml");
    } catch (e) {
      alert(e.message);
      return false;
    }
    if (validateXML.documentElement.nodeName == "parsererror") {
      var xmlString = (new XMLSerializer()).serializeToString(validateXML.documentElement);
      alert("Cannot save document. XML is not well-formed.");
      return false;
    }

    var saveForm = new FormData();
    var statusStr = "";
    if (status == "completed") { statusStr = "draft"; }
<?php
  echo "    saveForm.append(\"document\",\"$p_id\");\n";
  echo "    saveForm.append(\"surface\",\"$sfcid\");\n";
  echo "    saveForm.append(\"witness\",\"$p_witness\");\n";
  echo "    saveForm.append(\"transcription\",transcription);\n";
  echo "    saveForm.append(\"status\",statusStr);\n";
?>
    var request = new XMLHttpRequest();
    request.onload = function() { 
      if (this.status == "200" && this.response == "Success") {
        document.getElementById('saveBtn').className = saveBtn.className.replace(/[ ]?redBG/,"");
        txt = box.transcriptionFrame.innerHTML;
        savedText = getCode(box.transcriptionFrame.innerHTML,"xml");
        detectChange();
        box.transcriptionFrame.focus();
      } else {
        alert("Error saving the file");
        console.log(request.response);
      }
    };
    request.onerror = function() { console.log('ERROR','saveTranscription',this.status); };
    request.open("POST","saveTranscription.php");
    request.send(saveForm);
  }
  function completeTranscription() {
    status = "completed";
    document.getElementById('completeBtn').className += " redBG";
    saveTranscription();
  }


function detectChange() {
  saveBtn = document.getElementById("saveBtn");
  var transcription = getCode(box.transcriptionFrame.innerHTML,"xml");

  if (transcription != savedText) {
    if (saveBtn.className.indexOf("redFG") == -1) {
      saveBtn.className += " redFG";
    }
  } else {
    saveBtn.className = saveBtn.className.replace(/[ ]?redFG/,"");
  }
}

function resizeImgHolder() { return true; }

function showHelp() {
  document.getElementById('helpDiv').style.display='block';
}
function selectToolbars() {
  var btn = document.getElementById('toolbarsBtn');
  var tbD = document.getElementById('selectToolbarsDiv');
  btn.parentNode.appendChild(tbD);
  document.getElementById('selectToolbarsDiv').style.display='block';
  document.getElementById('selectToolbarsDiv').style.top = btn.offsetTop+"px";
  document.getElementById('selectToolbarsDiv').style.left = btn.offsetLeft+"px";
}

document.ongesturestart=new Function("event.preventDefault();");
document.ongesturechange=new Function("event.preventDefault();");
window.onbeforeprint =new Function("document.getElementById('printTranscription').innerHTML = box.transcriptionFrame.innerHTML;");
window.onresize=resizeImgHolder;
</script>

<style type="text/css">
  @media screen {
	.transcribe { height: 40%; overflow:auto }
        .print { display:none }
}
  @media print {
        .xoprint { display:none }
        .noprint { visibility: hidden; }
	.transcribe { height: auto; overflow:visible }
.transcriptionFrame { }
#printTranscription{
  visibility: visible;
  display: block;
  position: absolute;
  top: 50px;
  left: 10px;
  width: auto;
  height: auto;
  background-color: white;
  padding: 10px;
}
.ex { font-style: italic; }
.brev-y, .brev-es, .brev-er { font-style: italic; }
.supplied::before, .gap::before { content: "["; }
.supplied::after, .gap::after { content: "]"; }
  }
</style>
</head>

<body class="transcriptionBody" onload="addTranscriptionBox();">
<div id="printTranscription" class="print"></div>
<div id="transcriptionHeader">
  <div id="imgControls" class="noprint">
    <div id="magnifyLabel" class="label">Zoom: </div>
    <input type="button" id="demagnify" value="<" onclick="zoomOut();"/>
    <div id="magnifyPct"></div>
    <input type="button" id="magnify" value=">" onclick="zoomIn();"/>

    <br/>
    <div id="rotateLabel" class="label">Rotate:</div>
    <input type="button" id="rotateL" value="<" onclick="rotate(-90);"/>
    <input id="rotateLbl" maxlength="3" onkeyup="rotate();">
    <input type="button" id="rotateR" value=">" onclick="rotate(90);"/>
  </div>


  <div class="fontBig right"><?php echo "$p_witness: "; ?><span class="noprint"><a href="<?php echo "$rtndir"; ?>">Return to Work</a></span></div>
  <div class="transcriptionTitle"><b><?php echo "$work_title"; ?></b></div>
  <div id="imgHolder" class="noprint">
    <img id="image1" src="<?php echo "$p_page"; ?>" style="user-select: none;" ondragstart="return false;" alt=""/>
  </div>
</div>


<div id="selectToolbarsDiv">
Toolbars:<br/>
<span id="selectToolbarsSpan"></span>
<p style="text-align:center"><input type="button" id="closeTB" value="Close" onclick="document.getElementById('selectToolbarsDiv').style.display='none';" /></p>
</div>
<div id="helpDiv">
<p style="text-align:right; float:right; width:200px;"><input type="button" id="closeHelpTop" value="Close" onclick="document.getElementById('helpDiv').style.display='none';" /></p>
<?php include "transcriptionHelp.html"; ?>
<p style="text-align:center"><input type="button" id="closeHelp" value="Close" onclick="document.getElementById('helpDiv').style.display='none';" /></p>
</div>

</body>
</html>
